package com.atguigu.tingshu.handler;

import com.atguigu.tingshu.model.CDCEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;
import top.javatool.canal.client.annotation.CanalTable;
import top.javatool.canal.client.handler.EntryHandler;

/**
 * @author: atguigu
 * @create: 2023-12-23 10:53
 */
@Slf4j
@Component
@CanalTable("user_info") ////监听变更表
public class UserCdcHandler implements EntryHandler<CDCEntity> {

    @Autowired
    private RedisTemplate redisTemplate;

    /**
     * 监听用户表更新/逻辑删除，删除Redis缓存用户信息
     *
     * @param before
     * @param after
     */

    @Override
    public void update(CDCEntity before, CDCEntity after) {
        log.info("监听到用户表更新/逻辑删除，删除Redis缓存用户信息");
        Long id = after.getId();
        String redisKey = "user:userinfo:" + id;
        redisTemplate.delete(redisKey);
    }

}
